ARM64: initial backend import
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # A yes/no parameter that controls whether to cross-build for an ARM host.
46 ARM_HOSTED_BUILD="$9"
47
48 # A yes/no parameter that controls whether to cross-build for the iOS simulator
49 IOS_SIM_BUILD="${10}"
50
51 # The version number of the submission, e.g. 1007.
52 LLVM_SUBMIT_VERSION="${11}"
53
54 # The subversion number of the submission, e.g. 03.
55 LLVM_SUBMIT_SUBVERSION="${12}"
56
57 # The current working directory is where the build will happen. It may already
58 # contain a partial result of an interrupted build, in which case this script
59 # will continue where it left off.
60 DIR=`pwd`
61
62 DARWIN_VERS=`uname -r | sed 's/\..*//'`
63 echo DARWIN_VERS = $DARWIN_VERS
64
65 ################################################################################
66 # Run the build.
67
68 # Create the source tree we'll actually use to build, deleting
69 # tcl since it doesn't actually build properly in a cross environment
70 # and we don't really need it.
71 SRC_DIR=$DIR/src
72 rm -rf $SRC_DIR || exit 1
73 mkdir $SRC_DIR || exit 1
74 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
75 # We can't use the top-level Makefile as-is.  Remove the soft link:
76 rm $SRC_DIR/Makefile || exit 1
77 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
78 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
79
80 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/.*\.\([0-9]*\).*/\1/'`
81 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
82     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
83     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
84     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
85 fi
86 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
87     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
88 else
89     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
90 fi
91
92 SDKROOT_PATH=`xcodebuild -version -sdk $SDKROOT Path`
93
94 # Figure out how many make processes to run.
95 SYSCTL=`sysctl -n hw.activecpu`
96 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
97 # Builders can default to 2, since even if they are single processor,
98 # nothing else is running on the machine.
99 if [ -z "$SYSCTL" ]; then
100     SYSCTL=2
101 fi
102 JOBS_FLAG="-j $SYSCTL"
103
104 COMMON_CONFIGURE_OPTS="\
105   --prefix=$DEST_DIR$DEST_ROOT \
106   --enable-assertions=$LLVM_ASSERTIONS \
107   --enable-optimized=$LLVM_OPTIMIZED \
108   --disable-bindings \
109   --disable-zlib \
110   --enable-terminfo=no"
111
112 COMMON_MAKEFLAGS="\
113   UNIVERSAL=1 \
114   UNIVERSAL_SDK_PATH=$SDKROOT_PATH \
115   NO_RUNTIME_LIBS=1 \
116   DISABLE_EDIS=1 \
117   REQUIRES_RTTI=1 \
118   DEBUG_SYMBOLS=1 \
119   LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
120   LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
121   VERBOSE=1"
122
123 # Build the LLVM tree universal.
124 mkdir -p $DIR/obj-llvm || exit 1
125 cd $DIR/obj-llvm || exit 1
126
127 if [ "$ARM_HOSTED_BUILD" = yes ]; then
128   # The cross-tools' build process expects to find an existing cross toolchain
129   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
130   rm -rf $DIR/bin || exit 1
131   mkdir $DIR/bin || exit 1
132   for prog in ar nm ranlib strip lipo ld as ; do
133     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
134     T=`xcrun -sdk $SDKROOT -find ${prog}`
135     ln -s $T $DIR/bin/$prog
136     echo '#!/bin/sh' > $P || exit 1
137     echo 'exec '$T' "$@"' >> $P || exit 1
138     chmod a+x $P || exit 1
139   done
140   # Set up the links for clang.
141   for prog in clang clang++ ; do
142     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
143     T=`xcrun -sdk $SDKROOT -find ${prog}`
144     ln -s $T $DIR/bin/$prog
145     echo '#!/bin/sh' > $P || exit 1
146     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT_PATH}' "$@"' >> $P || exit 1
147     chmod a+x $P || exit 1
148   done
149
150   PATH=$DIR/bin:$PATH
151
152   unset SDKROOT && \
153   $SRC_DIR/configure $COMMON_CONFIGURE_OPTS \
154     --enable-targets=arm,arm64 \
155     --host=arm-apple-darwin10 \
156     --target=arm-apple-darwin10 \
157     --build=i686-apple-darwin10 \
158     --program-prefix="" \
159     || exit 1
160
161   if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
162     COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
163       DEPLOYMENT_TARGET=-mios-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
164   fi
165
166   make $JOBS_FLAG $COMMON_MAKEFLAGS SDKROOT= UNIVERSAL_ARCH="$HOSTS" \
167     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
168   if [ $? != 0 ] ; then
169     echo "error: LLVM 'make' failed!"
170     exit 1
171   fi 
172
173 else
174 # not $ARM_HOSTED_BUILD
175
176   if [ "$IOS_SIM_BUILD" = yes ]; then
177     export CC=`xcrun -sdk iphonesimulator -find clang`
178     export CXX=`xcrun -sdk iphonesimulator -find clang++`
179
180     # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
181     configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
182                     --build=i686-apple-darwin10"
183     if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
184       COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
185         DEPLOYMENT_TARGET=-mios-simulator-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
186     fi
187   else
188     export CC=`xcrun -sdk macosx -find clang`
189     export CXX=`xcrun -sdk macosx -find clang++`
190
191     configure_opts="--enable-targets=arm,arm64,x86"
192     if [ -n "$MACOSX_DEPLOYMENT_TARGET" ]; then
193       COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
194         DEPLOYMENT_TARGET=-mmacosx-version-min=$MACOSX_DEPLOYMENT_TARGET"
195     fi
196   fi
197
198   if [ $SDKROOT_PATH ]; then
199     CPPFLAGS="$CPPFLAGS -isysroot $SDKROOT_PATH"
200   fi
201   for host in $HOSTS; do :; done
202   CPPFLAGS="$CPPFLAGS -arch $host"
203
204   $SRC_DIR/configure $COMMON_CONFIGURE_OPTS $configure_opts \
205     --program-prefix="" \
206     CPPFLAGS="$CPPFLAGS" \
207     || exit 1
208
209   make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" \
210     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
211   if [ $? != 0 ] ; then
212     echo "error: LLVM 'make' failed!"
213     exit 1
214   fi 
215 fi 
216
217 ################################################################################
218 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
219 # $DEST_DIR, with occasional 'lipo' commands.
220
221 cd $DEST_DIR || exit 1
222
223 # Clean out DEST_DIR in case -noclean was passed to buildit.
224 rm -rf * || exit 1
225
226 cd $DIR/obj-llvm || exit 1
227
228 # Install the tree into the destination directory.
229 make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" install
230 if ! test $? == 0 ; then
231     echo "error: LLVM 'make install' failed!"
232     exit 1
233 fi 
234
235 # Install Version.h
236 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
237 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
238     LLVM_MINOR_VERSION=0
239 fi
240 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
241 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
242 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
243
244 # Run unifdef to preprocess the installed headers to reflect whether this
245 # was a debug or release build.
246 for file in `find $DEST_DIR$DEST_ROOT/include -type f -print`; do
247   if [ "$LLVM_ASSERTIONS" = yes ]; then
248     unifdef -UNDEBUG -D_DEBUG -o $file $file
249   else
250     unifdef -DNDEBUG -U_DEBUG -ULLVM_ENABLE_DUMP -o $file $file
251   fi
252 done
253
254 # Find the right version of strip to use.
255 STRIP=strip
256 if [ -n "$SDKROOT" ]; then
257   STRIP=`xcrun -sdk $SDKROOT -find strip`
258 fi
259
260 if [ "x$LLVM_DEBUG" != "x1" ]; then
261     # Strip local symbols from llvm libraries.
262     #
263     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
264     # PPC objects!
265     $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
266     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
267         $STRIP -Sxl $f
268     done
269 fi
270
271 # Remove .dir files 
272 cd $DEST_DIR$DEST_ROOT
273 rm -f bin/.dir etc/llvm/.dir lib/.dir
274
275 # The Hello dylib is an example of how to build a pass.
276 # The BugpointPasses module is only used to test bugpoint.
277 # These unversioned dylibs cause verification failures, so do not install them.
278 # (The wildcards are used to match a "lib" prefix if it is present.)
279 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
280 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
281
282 # Compress manpages
283 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
284 gzip -f $MDIR/*
285
286 ################################################################################
287 # Create SYM_DIR with information required for debugging.
288
289 # Figure out how many make processes to run.
290 SYSCTL=`sysctl -n hw.activecpu`
291
292 # hw.activecpu only available in 10.2.6 and later
293 if [ -z "$SYSCTL" ]; then
294   SYSCTL=`sysctl -n hw.ncpu`
295 fi
296
297 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
298 # can default to 2, since even if they are single processor, nothing else is
299 # running on the machine.
300 if [ -z "$SYSCTL" ]; then
301   SYSCTL=2
302 fi
303
304 cd $SYM_DIR || exit 1
305
306 # Clean out SYM_DIR in case -noclean was passed to buildit.
307 rm -rf * || exit 1
308
309 # Generate .dSYM files
310 DSYMUTIL=`xcrun -find dsymutil`
311 find $DEST_DIR -perm -0111 -type f \
312     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
313     -print | xargs -n 1 -P ${SYSCTL} ${DSYMUTIL}
314
315 # Save .dSYM files and .a archives
316 cd $DEST_DIR || exit 1
317 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
318     | cpio -pdml $SYM_DIR || exit 1
319
320 # Save source files.
321 mkdir $SYM_DIR/src || exit 1
322 cd $DIR || exit 1
323 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
324     | cpio -pdml $SYM_DIR/src || exit 1
325
326 ################################################################################
327 # Remove libLTO.dylib and lto.h.  Those are installed by clang.
328
329 cd $DEST_DIR$DEST_ROOT
330 rm -f lib/libLTO.dylib
331 rm -f lib/libLTO.a lib/libLTO.la
332 find $DEST_DIR$DEST_ROOT -name lto.h -delete
333
334 ################################################################################
335 # Remove debugging information from DEST_DIR.
336
337 cd $DIR || exit 1
338
339 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
340 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
341
342 # Strip debugging information from files
343 #
344 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
345 # PPC objects!
346 find $DEST_DIR -perm -0111 -type f \
347     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
348     -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
349
350 chgrp -h -R wheel $DEST_DIR
351 chgrp -R wheel $DEST_DIR
352
353 ################################################################################
354 # Remove the docs directory
355
356 rm -rf $DEST_DIR$DEST_ROOT/docs
357
358 ################################################################################
359 # w00t! Done!
360
361 exit 0